unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Inifiles, Fmxutils, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    btnPreProcess: TButton;
    btnPostProcess: TButton;
    lblCpath: TLabel;
    lblApath: TLabel;
    btnCompile: TButton;
    btnAssemble: TButton;
    lblProject: TLabel;
    btnEdit: TButton;
    btnViewl51: TButton;
    btnViewa51: TButton;
    btnLink: TButton;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Bevel1: TBevel;
    Help1: TMenuItem;
    About1: TMenuItem;
    procedure btnPreProcessClick(Sender: TObject);
    procedure WriteItOut(var S:String);
    procedure ProcessStrings;
    procedure ProcessInclude;
    procedure ProcessIla;
    procedure ProcessLabel(S:String);
    function GetStartAddr(S:String) : longint;
    procedure btnPostProcessClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lblProjectDblClick(Sender: TObject);
    procedure btnEditClick(Sender: TObject);
    procedure btnCompileClick(Sender: TObject);
    procedure btnViewl51Click(Sender: TObject);
    procedure btnViewa51Click(Sender: TObject);
    procedure btnAssembleClick(Sender: TObject);
    procedure lblCpathDblClick(Sender: TObject);
    procedure lblApathDblClick(Sender: TObject);
    procedure btnLinkClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

  private

    { Private declarations }
  public
    Hitlist : TStringList;
    appIni : TIniFile;
    { Public declarations }
  end;

var
  Form1: TForm1;
  InF, OuP, OuA, OuI, InA, InS : TextFile ;
  StringsCount : integer;
  firstAddr, theAddr : longint;
  StrProcessed, HasAssembler : boolean;
  compilerpath,asm51path,projpath : string;

implementation

uses Unit2, Unit3;

{$R *.DFM}

Function TForm1.GetStartAddr(S:String) : longint;
var
  i : integer;
  theAddr : longint;
  wS : String;

begin
  theAddr := 0;
  StringsCount := 0;
  wS := UpperCase(s);
  if Pos('START AT $',wS) = 0 then
  begin
    Listbox1.items.add(S);
    Listbox1.items.add('Error - No Start address found for strings');
  end
  else
  begin
    i := Pos('$',S);
    theAddr := StrToInt(Copy(S,i,5));
  end;
  result := theAddr;
end;

procedure TForm1.ProcessInclude;
var
  S : String;
begin
  while not eof(InS) do {next do strings include}
  begin
    readln(InS,S);
    writeln(OuA,S);
  end;

  writeln(OuA,chr(9) + 'END' + chr(9)); {write final 'END' to assembler file}
end;

procedure TForm1.ProcessIla;
var
  S : String;
begin
  if HasAssembler then {process inline assembler include}
  begin
    while not eof(OuI) do {.ila include}
    begin
      readln(OuI,S);
      writeln(OuA,S);
    end;
  end;
end;


procedure TForm1.ProcessLabel(S:String);
{compare the label at the start of the string with the procnames
in hitlist. If found, zap the asm code lines by reading them off the
input file InA}
var
i : integer;
lab,gash : string;
begin;
  i := Pos(':',s);
  lab := uppercase(copy(s,1,i-1));
  if HitList.IndexOf(lab) <> -1 then {found one to remove}
  begin
    repeat
      readln(InA,gash);
    until ((Pos('RET',gash) <> 0) and (gash[1] <> ';')) or (eof(InA));
    if eof(InA) then
     listbox1.Items.add('Unexpected EOF, Assembler external procedure ' + lab)
    else
     listbox1.Items.add('Assembler procedure ' + lab + ' processed')
  end
  else writeln(OuA,S);

end;

procedure TForm1.ProcessStrings;
var
i : integer;
S, varname, theString : string;
firsttime : boolean;

begin
  StrProcessed := True;
  FirstTime := True;
  readln(InF,S);
  S := Trim(S);
  while S <> '' do
  begin
    if FirstTime then
    begin
      theAddr := GetStartAddr(S);
      firstAddr := theAddr;
      readln(InF,S);
      FirstTime := false;
      writeln(OuP,'   {Stringlist generated on ' + datetostr(date) + ' at ' + timetostr(time) + '}');
      writeln(OuA,';');
      writeln(OuA,'; Stringlist generated on ' + datetostr(date) + ' at ' + timetostr(time));
      writeln(OuA,chr(9),'CSEG at ',intTohex(theAddr,4),'H');
      writeln(OuA,chr(9),'ORG ',intTohex(theAddr,4),'H');
    end;

    i := Pos(':=',S);
    varname := copy(s,1,i-1);
    varname := trim(varname);
    i := Pos('''',S);
    theString := Copy(S,i+1,length(S)-i - 2);
    Listbox1.items.add('Processing string at $' + intTohex(theAddr,4));
    write(OuP, '   ',varname,' at $',intTohex(theAddr,4),' : string;');
    writeln(OuP,' {',theString,'}');
    writeln(OuA,chr(9),'DB ',length(theString));
    writeln(OuA,chr(9),'DB ''',theString,  '''');
    theAddr := theAddr + length(theString) + 1;
    StringsCount := StringsCount + 1;
    readln(InF,S);
    S := Trim(S);
  end;
  Listbox1.items.add('Finished processing ' + IntToStr(StringsCount) + ' string(s)');
  Listbox1.items.add('Strings Start Address = $' + intTohex(firstAddr,4) + ', Last Address = $' + intTohex(theAddr,4));
  Listbox1.items.add('Total string space = $' + InttoHex(theAddr - firstAddr,4) + '  (' + IntToStr(theAddr - firstAddr) + ' bytes)');
end;

procedure Convert_Char(var s:String);
var
 sch,numstr : string;
 i,st : integer;
 allDone, gotOne : boolean;

begin
  allDone := false;
  while allDone = false do
    begin
    gotOne := false;
    for i := 14 to 127 do
    begin
      sch := '''' + chr(i) + '''';
      st := Pos(sch,s);
      if st <> 0 then
      begin
        numstr:= IntToHex(ord(i),2);
        insert('$' + numstr + ' {', s, st);
        st := Pos(sch,s) + 3;
        insert('}',s,st);
        st := Pos(sch,s);
        s[st] := chr(96); //replace ' with open quote.
        s[st+2] := chr(180);//and aclose quote
        gotOne := true;
      end;
    end;
    if gotOne then allDone := false else allDone := true;
    //allDone := true;
  end;
end;

procedure TForm1.WriteItOut(var s:String);
var
 i,j : integer;
 wS, wS1 : String;
 procname, fpath, fname,OutName : String;
begin
  wS := UpperCase(s);

  if Pos('{*EXTERNAL}',wS) <> 0 then
  {This line has the name of a procedure which is implemented
   elsewhere in existing asm code.
   So, add the name of the procedure to a hitlist. This list will
   be used later to strip out the code planted in the .a51 file
   by Pascal51 compiler}
  begin
    i := Pos('PROCEDURE',wS);
    i := i + 10;
    j := Pos(';',wS);
    procname := trim(procname);
    procname := copy(ws,i,j-i);
    HitList.add(procname);
    Listbox1.items.add('External procedure ' + procname + ' processed.');
  end
  else if Pos('{*ASSEMBLER}',wS) <> 0 then
  {This line has the name of a procedure which is implemented
   inline in the P80 code.
   So, copy the lines between the 'begin' and 'end;' to the
   .ila (In Line Assembler) file. This file must be included
   in the final assembly}
  begin
    if not HasAssembler then {1st time in only}
    begin
      fPath := ExtractFilePath(ProjPath);
      fName := ExtractFileName(ProjPath);
      fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
      OutName := fPath + fName + 'ila';
      AssignFile(OuI, OutName);   { File selected in dialog box }
      Rewrite(OuI);
      writeln(OuI,';');  {write to inline assembler source file}
      writeln(OuI,'; Inline assembler generated on ' + datetostr(date) + ' at ' + timetostr(time));
      writeln(OuI,';');  {write to inline assembler source file}
      HasAssembler := True;
    end;
    writeln(OuP,s); {write to Pascal51 source file}
    i := Pos('PROCEDURE',wS);
    i := i + 10;
    j := Pos(';',wS);
    procname := copy(ws,i,j-i);
    procname := trim(procname);
    HitList.Add(procname);
    procname := procname + ':';
    writeln(OuI,procname);  {write to inline assembler source file}
    Listbox1.items.add('Assembler procedure ' + procname + ' processed.');
    readln(InF,wS);
    wS1 := UpperCase(wS);
    while Pos('END;',wS1) = 0 do
    begin
      if Pos('BEGIN',wS1) <> 0 then
        writeln(OuP,wS) {write to Pascal51 source file}
      else
      begin
        writeln(OuP,'{ ',wS, ' }'); {write to Pascal51 source file}
        writeln(OuI,wS);  {write to inline assembler source file}
      end;
      readln(InF,wS);
      wS1 := UpperCase(wS);
    end;
    writeln(OuI,';');  {write to inline assembler source file}
    s := wS;
  end
  else convert_char(s); {deal with changing all 'n' to ascii values}

  writeln(OuP,s); {write to Pascal51 source file}
end;

procedure TForm1.btnPreProcessClick(Sender: TObject);
var
 s : string;
 outname, fPath, fName : string;

begin
  ListBox1.clear;
  if FileExists(ProjPath) then
  begin
    Hitlist := TStringList.Create;   {list of 'External' procedures}
    AssignFile(InF, ProjPath);   { Current project }
    Reset(InF);
    fPath := ExtractFilePath(ProjPath);
    fName := ExtractFileName(ProjPath);
    fName := Copy(fName,1,length(fName)-3);

    OutName := fPath + fName + 'p51';
    AssignFile(OuP, OutName);   { File selected in dialog box }
    Rewrite(OuP);
    OutName := fPath + fName + 'asi';
    AssignFile(OuA, OutName);   { File selected in dialog box }
    Rewrite(OuA);

    StrProcessed := False; {haven't done any strings}
    HasAssembler := False; {inline assembler not found yet}

    While not eof(InF) do
    begin
      Readln(InF, S);          { Read the first line out of the file }
      if (Pos('Strings',S) > 0) and not StrProcessed then
        ProcessStrings
      else
        WriteItOut(S);
    end;

    CloseFile(InF);
    CloseFile(OuP);
    CloseFile(OuA);
    if HasAssembler then CloseFile(OuI); {if any InLine Assembler found}
  end
  else
    showmessage('Project (.p80) file not found! - Double click on Project label to select a project.');
end;

procedure TForm1.btnPostProcessClick(Sender: TObject);
var
 s : string;
 outname, fPath, fName : string;

begin
{read in a a51 file and merge in .asi (strings include) file.}
    fPath := ExtractFilePath(ProjPath);
    fName := ExtractFileName(ProjPath);
    fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}

    OutName := fPath + fName + 'a51';
    AssignFile(InA, OutName);   { Pascal51 generated asm file }
    Reset(InA);
    OutName := fPath + fName + 'asi';
    AssignFile(InS, OutName);   { Generated strings include file }
    Reset(InS);
    OutName := fPath + fName + 'ila';
    AssignFile(Oui, OutName);   { Generated inline assembler include file }
    Reset(Oui);

    OutName := fPath + fName + 'a80';
    AssignFile(OuA, OutName);   { Generated final asm file }
    Rewrite(OuA);

    While not eof(InA) do  {while not end of .a51 file}
    begin
      Readln(InA, S);
      if not (S[1] in [' ',';']) and (Pos(':',S) <> 0) then
        ProcessLabel(S)
      else if Pos('----- End Of Pascal51 Relocate Segment -----',S) <> 0 then {insert .ila}
        ProcessIla         {insert the .ila file}
      else if Pos(chr(9) + 'END' + chr(9),S) <> 0 then {end of .a51 file}
        ProcessInclude     {append the .asi file to the .a80 file}

      else
        writeln(OuA,S);
    end;

    Listbox1.items.add('Finished processing assembler file');

    CloseFile(InA);
    CloseFile(InS);
    CloseFile(OuA);
    CloseFile(Oui);
    Hitlist.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  appIni := TInifile.Create('pascal80.ini');
  CompilerPath := appIni.ReadString('compiler','path','Double click here to select Pascal51 Compiler path');
  lblCpath.Caption := 'Compiler : ' + CompilerPath;
  Asm51Path := appIni.ReadString('assembler','path','Double click here to select ASM51 path');
  lblApath.Caption := 'Assembler : ' + Asm51Path;
  ProjPath := appIni.ReadString('project','path','Double click here to select a project (.p80) file');
  lblProject.Caption := 'Project : ' + ProjPath;
end;



procedure TForm1.lblProjectDblClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Pascal80 Project file|*.p80';
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Appini.WriteString('project','path',OpenDialog1.FileName);   { File selected in dialog box }
    ProjPath := OpenDialog1.FileName;
    lblProject.Caption := 'Project : ' + ProjPath;
  end;
end;

procedure TForm1.btnEditClick(Sender: TObject);
begin
  ExecuteFile(ProjPath, '','', SW_SHOW);
end;

procedure TForm1.btnCompileClick(Sender: TObject);
var
  fPath, fName, aName, lName, sOptions : string;

begin
  if FileExists(CompilerPath) then
  begin
    sOptions := '';
    if form2.ckbDebug.State = cbChecked then sOptions := sOptions + '-d ';
    if form2.ckbStop.State = cbChecked then sOptions := sOptions + '-e ';
    sOptions := sOptions + '-x' + form2.edtStart.text;
    fPath := ExtractFilePath(ProjPath);
    fName := ExtractFileName(ProjPath);
    fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
    aName := fName + 'a51';
    lName := fName + 'l51';
    fName := fName + 'p51';
    ExecuteFile(CompilerPath , sOptions + ' ' + fName + ' ' + aName + ' ' + lName, fPath, SW_SHOW);
   end
  else
    ShowMessage('Pascal Compiler .exe file not found! - Double click on the compiler label to locate it.');
end;



procedure TForm1.btnViewl51Click(Sender: TObject);
var
  fPath, fName : string;

begin
  fPath := ExtractFilePath(ProjPath);
  fName := ExtractFileName(ProjPath);
  fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
  fName := fName + 'l51';
  ExecuteFile(fPath + fName, '','', SW_SHOW);
end;

procedure TForm1.btnViewa51Click(Sender: TObject);
var
  fPath, fName : string;

begin
  fPath := ExtractFilePath(ProjPath);
  fName := ExtractFileName(ProjPath);
  fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
  fName := fName + 'lst';
  ExecuteFile(fPath + fName, '','', SW_SHOW);
end;

procedure TForm1.btnAssembleClick(Sender: TObject);
var
  fPath, fName : string;
begin
  if FileExists(Asm51Path) then
  begin
    fPath := ExtractFilePath(ProjPath);
    fName := ExtractFileName(ProjPath);
    fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
    fName := fName + 'a80';
    ExecuteFile(Asm51Path , fName, fPath, SW_SHOW);
  end
  else
    ShowMessage('8051 Assembler .exe file not found! - double click assembler label to locate.');
end;

procedure TForm1.lblCpathDblClick(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.lblApathDblClick(Sender: TObject);
begin
 OpenDialog1.Filter := 'ASM51 assembler .exe file|*.exe';
 if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Appini.WriteString('assembler','path',OpenDialog1.FileName);   { File selected in dialog box }
    Asm51Path := OpenDialog1.FileName;
    lblApath.Caption := 'Assembler : ' + Asm51Path;
  end;
end;



procedure TForm1.btnLinkClick(Sender: TObject);
var
  fPath, fName, Bat51Path : string;
begin
  fPath := ExtractFilePath(ProjPath);
  fName := ExtractFileName(ProjPath);
  fName := Copy(fName,1,length(fName)-3); {remove file extension - 3 chars only}
  fName := fName + 'bat';
  Bat51Path := fPath + fName;
  if FileExists(Bat51Path) then
    ExecuteFile(Bat51Path , fName, fPath, SW_SHOW)
  else
    showmessage('Batch file ' + Bat51Path + ' not found! - You have to create this file yourself.');
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
  application.terminate;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.Show;
end;

end.
